SystemOrganization addCategory: #'TxText-AthensTests'!

TestCase subclass: #TxAthensTextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-AthensTests'!

TxAthensTextTest subclass: #TxAthensLayoutTest
	instanceVariableNames: 'text layout view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-AthensTests'!

!TxAthensLayoutTest methodsFor: 'private' stamp: 'FernandoOlivero 8/25/2013 10:09'!
defaultLayoutViewExtent
	^ 100@100! !

!TxAthensLayoutTest methodsFor: 'private' stamp: 'FernandoOlivero 8/25/2013 10:06'!
defaultText
^
'"Lorem
ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."
Section 1.10.32 of "de Finibus Bonorum et Malorum", written by Cicero in 45 BC

"Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?"
1914 translation by H. Rackham

"But I must explain to you how all this mistaken idea of denouncing pleasure and praising pain was born and I will give you a complete account of the system, and expound the actual teachings of the great explorer of the truth, the master-builder of human happiness. No one rejects, dislikes, or avoids pleasure itself, because it is pleasure, but because those who do not know how to pursue pleasure rationally encounter consequences that are extremely painful. Nor again is there anyone who loves or pursues or desires to obtain pain of itself, because it is pain, but because occasionally circumstances occur in which toil and pain can procure him some great pleasure. To take a trivial example, which of us ever undertakes laborious physical exercise, except to obtain some advantage from it? But who has any right to find fault with a man who chooses to enjoy a pleasure that has no annoying consequences, or one who avoids a pain that produces no resultant pleasure?"
Section 1.10.33 of "de Finibus Bonorum et Malorum", written by Cicero in 45 BC

"At vero eos et accusamus et iusto odio dignissimos ducimus qui blanditiis praesentium voluptatum deleniti atque corrupti quos dolores et quas molestias excepturi sint occaecati cupiditate non provident, similique sunt in culpa qui officia deserunt mollitia animi, id est laborum et dolorum fuga. Et harum quidem rerum facilis est et expedita distinctio. Nam libero tempore, cum soluta nobis est eligendi optio cumque nihil impedit quo minus id quod maxime placeat facere possimus, omnis voluptas assumenda est, omnis dolor repellendus. Temporibus autem quibusdam et aut officiis debitis aut rerum necessitatibus saepe eveniet ut et voluptates repudiandae sint et molestiae non recusandae. Itaque earum rerum hic tenetur a sapiente delectus, ut aut reiciendis voluptatibus maiores alias consequatur aut perferendis doloribus asperiores repellat."
'.

	! !

!TxAthensLayoutTest methodsFor: 'running' stamp: 'FernandoOlivero 8/25/2013 10:08'!
setUp
	text := self newText: self defaultText.
	view := self newViewOn: text.! !

!TxAthensLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/6/2013 18:22'!
testFreshViewLayoutNotNil
		
	self assert: view layout isNil not ! !

!TxAthensLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/6/2013 18:08'!
testFreshViewOffsetShouldBeZero
	"initially origin should be set to 0@0 "
	
	
	self assert: view offset equals: 0@0! !

!TxAthensLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/6/2013 18:11'!
testFreshViewPositionIsAtStart
	"layout should answer text position from visual position"
	self assert: view layout startPosition equals: text startPosition! !

!TxAthensLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/8/2013 17:57'!
testLayoutShouldComputeExtent
	"text is not empty, so layout should be not empty either"
	self assert: view layout extent x isZero not.
	self assert: view layout extent y isZero not.
	
! !

!TxAthensLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 10/14/2013 12:01'!
testLayoutShouldHaveNoGaps
	"check that layout has no gaps"
	self assert: view layout isWellFormed! !

!TxAthensLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/5/2013 17:21'!
testSettingViewExtent
	"layout should answer text position from visual position"
	
	
	view extent:100@100.
	
	self assert: view extent equals:100@100! !

!TxAthensTextTest methodsFor: 'private' stamp: 'FernandoOlivero 8/26/2013 17:17'!
defaultStrategy
	^ TxAthensNoWrapStrategy new! !

!TxAthensTextTest methodsFor: 'private' stamp: 'IgorStasenko 8/30/2013 13:39'!
newText: aString
	| text |
	text := TxModel new.
	text endPosition insert:  aString.
	^ text! !

!TxAthensTextTest methodsFor: 'private' stamp: 'FernandoOlivero 8/26/2013 17:16'!
newViewOn: aText 
	| layoutView |
	layoutView :=  TxAthensLayoutView on: aText extent: self defaultLayoutViewExtent.
	layoutView layoutStrategy: self defaultStrategy.
	^ layoutView! !

TxAthensTextTest subclass: #TxAthensTextTransformsTest
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-AthensTests'!

!TxAthensTextTransformsTest methodsFor: 'private' stamp: 'FernandoOlivero 8/26/2013 17:15'!
defaultLayoutViewExtent
	^ 100@500.! !

!TxAthensTextTransformsTest methodsFor: 'private' stamp: 'FernandoOlivero 8/26/2013 17:17'!
defaultStrategy
	^ TxAthensCharacterWrappingStrategy new! !

!TxAthensTextTransformsTest methodsFor: 'private' stamp: 'FernandoOlivero 8/26/2013 15:57'!
defaultText
	^ 'The view coordinates should be properly transformed into a text position to interact with a text being displayed'! !

!TxAthensTextTransformsTest methodsFor: 'running' stamp: 'FernandoOlivero 8/26/2013 15:55'!
setUp
	| text |
	text := self newText: self defaultText.
	view := self newViewOn: text.! !

TxAthensTextTransformsTest subclass: #TxTextPositionToViewCoordinatesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-AthensTests'!

TxAthensTextTransformsTest subclass: #TxViewCoordinatesToTextPositionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-AthensTests'!

!TxViewCoordinatesToTextPositionTest methodsFor: 'tests' stamp: 'IgorStasenko 8/30/2013 13:24'!
testLayoutPositionShouldBeBeyondStartPosition
	|  oneCharRight layoutPosition |
	
	oneCharRight := view layout startPosition copy moveRight.
	layoutPosition := view layoutPositionAt: oneCharRight ifOutside: [  self assert: false ].

	self assert: view text == oneCharRight text.
	
	self assert: layoutPosition baselinePoint x > 0.! !

!TxViewCoordinatesToTextPositionTest methodsFor: 'tests' stamp: 'IgorStasenko 8/27/2013 15:38'!
testOriginMovedRightShouldIncreaseTextPosition
	| position oneCharRight pt layoutPosition |
	
	oneCharRight := view layout startPosition copy moveRight.
	layoutPosition := view layoutPositionAt: oneCharRight ifOutside: [  self assert: false ].
	pt := layoutPosition baselinePointInView.
	
	position := view textPositionAt: pt + (1@0).

	self assert: position = oneCharRight! !

!TxViewCoordinatesToTextPositionTest methodsFor: 'tests' stamp: 'IgorStasenko 10/15/2013 12:35'!
testOriginShouldTransformToStartPosition
	| position |
	position := view textPositionAt: 0@0.
	self assert: position asTextIndex = view layout startPosition asTextIndex .! !

TxAthensTextTest subclass: #TxLayoutStrategyTest
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-AthensTests'!

TxLayoutStrategyTest subclass: #TxCharacterWrappingStrategyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-AthensTests'!

!TxCharacterWrappingStrategyTest methodsFor: 'private' stamp: 'FernandoOlivero 8/26/2013 17:16'!
defaultStrategy
	^ TxAthensCharacterWrappingStrategy new 
	

! !

!TxCharacterWrappingStrategyTest methodsFor: 'testing' stamp: 'FernandoOlivero 8/25/2013 11:22'!
testLayoutShouldContainMultipleLines
	self assert: (view layout numberOfLines >  1)! !

!TxLayoutStrategyTest methodsFor: 'private' stamp: 'IgorStasenko 8/26/2013 11:28'!
defaultLayoutViewExtent
	^ 10@1000! !

!TxLayoutStrategyTest methodsFor: 'private' stamp: 'FernandoOlivero 8/25/2013 10:15'!
defaultText
	^ 'Pharo is a modern Smalltalk implementation'! !

!TxLayoutStrategyTest methodsFor: 'running' stamp: 'FernandoOlivero 8/25/2013 10:13'!
setUp
	| text |
	text := self newText: self defaultText.
	view := self newViewOn: text.! !

TxLayoutStrategyTest subclass: #TxNoWrapStrategyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-AthensTests'!

!TxNoWrapStrategyTest methodsFor: 'private' stamp: 'FernandoOlivero 8/26/2013 17:16'!
defaultStrategy
	^ TxAthensNoWrapStrategy new ! !

!TxNoWrapStrategyTest methodsFor: 'tests' stamp: 'FernandoOlivero 8/25/2013 10:41'!
testLayoutShouldContainASingleLine
	self assert: (view layout numberOfLines =  1)! !

TxAthensTextTest subclass: #TxTextLayoutTest
	instanceVariableNames: 'view1 view2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-AthensTests'!

TxTextLayoutTest subclass: #TxMultilineSmallTextLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-AthensTests'!

!TxMultilineSmallTextLayoutTest methodsFor: 'private' stamp: 'FernandoOlivero 8/25/2013 09:58'!
defaultLayoutViewExtent 
	^ 100@10000.
	! !

!TxMultilineSmallTextLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/8/2013 17:58'!
testAddingLineShouldIncreaseLayoutHeight
 

	self assert: (view1 layout extent y < view2 layout extent y)! !

!TxMultilineSmallTextLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/8/2013 17:54'!
testLayoutExtentHeightShouldNotBeZero

	self assert: (view1 layout extent y ~= 0)! !

!TxMultilineSmallTextLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/8/2013 18:11'!
testView1LayoutShouldHaveTwoLines

	self assert: view1 layout lines size equals: 2.
	! !

!TxMultilineSmallTextLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/8/2013 18:12'!
testView2LayoutShouldHaveThreeLines

	self assert: view2 layout lines size equals: 3.
	! !

!TxMultilineSmallTextLayoutTest methodsFor: 'private' stamp: 'FernandoOlivero 8/25/2013 09:58'!
textForView1
^
'1: Line 1
2: Line2'.
! !

!TxMultilineSmallTextLayoutTest methodsFor: 'private' stamp: 'FernandoOlivero 8/25/2013 09:58'!
textForView2
^
'1: Line 1
2: Line2
3: Line3'.
! !

TxTextLayoutTest subclass: #TxOneLineTextLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-AthensTests'!

!TxOneLineTextLayoutTest methodsFor: 'private' stamp: 'FernandoOlivero 8/25/2013 09:55'!
defaultLayoutViewExtent 
	^ 1000@10000! !

!TxOneLineTextLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/8/2013 18:10'!
testLayoutShouldHaveOneLine

	self assert: view1 layout lines size equals: 1.
	self assert: view2 layout lines size equals: 1.
	! !

!TxOneLineTextLayoutTest methodsFor: 'tests' stamp: 'IgorStasenko 8/8/2013 18:03'!
testLineSizeIncreasesLayoutExtent
 

	self assert: (view1 layout extent x< view2 layout extent x)! !

!TxOneLineTextLayoutTest methodsFor: 'private' stamp: 'FernandoOlivero 8/25/2013 10:01'!
textForView1
	^ '1'! !

!TxOneLineTextLayoutTest methodsFor: 'private' stamp: 'FernandoOlivero 8/25/2013 10:01'!
textForView2
	^ '12'! !

!TxTextLayoutTest methodsFor: 'private' stamp: 'FernandoOlivero 8/25/2013 09:57'!
defaultLayoutViewExtent
	^ self subclassResponsibility ! !

!TxTextLayoutTest methodsFor: 'running' stamp: 'FernandoOlivero 8/25/2013 10:12'!
setUp
	| text |
	text := self newText: self textForView1.
	view1 := self newViewOn:  text .
	
	text := self newText: self textForView2.
	view2 := self newViewOn:  text .
! !

!TxTextLayoutTest methodsFor: 'private' stamp: 'FernandoOlivero 8/25/2013 09:57'!
textForView1
	^ self subclassResponsibility ! !

!TxTextLayoutTest methodsFor: 'private' stamp: 'FernandoOlivero 8/25/2013 09:57'!
textForView2
	^ self subclassResponsibility ! !

Object subclass: #TxAthensRenderingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TxText-AthensTests'!

!TxAthensRenderingTest class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/23/2013 14:11'!
newText
	| text |
	text := TxModel new.
	
	text endPosition insert: '"Lorem
ipsum dolor sit
amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."
Section 1.10.32 of "de Finibus Bonorum et Malorum", written by Cicero in 45 BC

"Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?"
1914 translation by H. Rackham

"But I must explain to you how all this mistaken idea of denouncing pleasure and praising pain was born and I will give you a complete account of the system, and expound the actual teachings of the great explorer of the truth, the master-builder of human happiness. No one rejects, dislikes, or avoids pleasure itself, because it is pleasure, but because those who do not know how to pursue pleasure rationally encounter consequences that are extremely painful. Nor again is there anyone who loves or pursues or desires to obtain pain of itself, because it is pain, but because occasionally circumstances occur in which toil and pain can procure him some great pleasure. To take a trivial example, which of us ever undertakes laborious physical exercise, except to obtain some advantage from it? But who has any right to find fault with a man who chooses to enjoy a pleasure that has no annoying consequences, or one who avoids a pain that produces no resultant pleasure?"
Section 1.10.33 of "de Finibus Bonorum et Malorum", written by Cicero in 45 BC

"At vero eos et accusamus et iusto odio dignissimos ducimus qui blanditiis praesentium voluptatum deleniti atque corrupti quos dolores et quas molestias excepturi sint occaecati cupiditate non provident, similique sunt in culpa qui officia deserunt mollitia animi, id est laborum et dolorum fuga. Et harum quidem rerum facilis est et expedita distinctio. Nam libero tempore, cum soluta nobis est eligendi optio cumque nihil impedit quo minus id quod maxime placeat facere possimus, omnis voluptas assumenda est, omnis dolor repellendus. Temporibus autem quibusdam et aut officiis debitis aut rerum necessitatibus saepe eveniet ut et voluptates repudiandae sint et molestiae non recusandae. Itaque earum rerum hic tenetur a sapiente delectus, ut aut reiciendis voluptatibus maiores alias consequatur aut perferendis doloribus asperiores repellat."
'.

	^ text! !

!TxAthensRenderingTest class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/12/2013 12:56'!
test
	| text view  sceneView sel |
	text := self newText.
	
	sel := text select all.

	sel applyAttribute: (TxFontAttribute with: (LogicalFont familyName: 'Arial'
 pointSize: 10)).

	sel end 
		moveToStart;
		moveRight: 22.
	sel
		applyAttribute: (TxFontAttribute with: (LogicalFont familyName: 'Tahoma'
 pointSize: 20)).
	view := nil.
	
	sceneView := AthensSceneView new scene:
		[ :canvas |
			view ifNil: [ 
				view := TxAthensLayoutView surface: canvas surface on:text extent:300@200.
				 ].
			view surface: canvas surface.
			view renderOn: canvas.
		 ].
	^ sceneView openInWindow.
! !
